import java.awt.*;

import java.awt.geom.*;
import java.io.*;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.*;
import javax.swing.*;

// x, y, z, rayon de la bulle, 

public class Graph extends JPanel {
	public String path;
	public ArrayList<Particule> alParticules;

	public Graph(String path) {
		this.alParticules = new ArrayList<Particule>();
		this.path = path;
	}

	private void lectureDonnees() {

		try {
			FileReader fr;
			fr = new FileReader(this.path);
			BufferedReader br = new BufferedReader(fr);
			String s;
			while ((s = br.readLine()) != null) {
				// System.out.println(s);
				Scanner scanner = new Scanner(s);
				Particule p = new Particule(Double.parseDouble(scanner.next("[\\S ]+")),
						Double.parseDouble(scanner.next("[\\S ]+")), Double.parseDouble(scanner.next("[\\S ]+")),
						Double.parseDouble(scanner.next("[\\S ]+")), Double.parseDouble(scanner.next("[\\S ]+")));
				// System.out.println(p);
				this.alParticules.add(p);
			}
			fr.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);

		this.lectureDonnees();
		plusProcheVoisin();
		// int hauteur = getHeight();
		// int largeur = getWidth();

		char[] c1 = { 'X', 'Y' };
		g2.drawChars(c1, 0, 2, 175, 340);
		for (Particule p : this.alParticules) {
			g2.setColor(p.color);
			g2.fill(new Ellipse2D.Double(p.x * 30, p.y * 30, 5, 5));
		}
		g2.setColor(Color.BLACK);
		g2.drawLine(350, 0, 350, 350);

		char[] c3 = { 'X', 'Z' };
		g2.drawChars(c3, 0, 2, 525, 340);
		for (Particule p : this.alParticules) {
			g2.setColor(p.color);
			g2.fill(new Ellipse2D.Double(p.x * 30 + 350, (p.z - 100) * 10, 5, 5));
		}
		g2.setColor(Color.BLACK);
		g2.drawLine(700, 0, 700, 350);

		char[] c2 = { 'Y', 'Z' };
		g2.drawChars(c2, 0, 2, 875, 340);
		for (Particule p : this.alParticules) {
			g2.setColor(p.color);
			g2.fill(new Ellipse2D.Double(p.y * 30 + 700, (p.z - 100) * 10, 5, 5));
		}

	}

	/*
	 * private void memeRayon(){ HashMap<Double,ArrayList<Particule>> hashmap =
	 * new HashMap<Double, ArrayList<Particule>>(); for(Particule p :
	 * this.alParticules){ if(hashmap.containsKey(p.rayon)){
	 * hashmap.get(p.rayon).add(p); }else{ hashmap.put(p.rayon, new
	 * ArrayList<Particule>()); hashmap.get(p.rayon).add(p); } }
	 * 
	 * ArrayList<Double> alRayons = new ArrayList<Double>();
	 * alRayons.addAll(hashmap.keySet());
	 * 
	 * System.out.println("nb Particules : "+this.alParticules.size());
	 * System.out.println("nb Rayons : "+alRayons.size());
	 * 
	 * for(Double d : alRayons){ System.out.println(d); if(hashmap.get(d).size()
	 * == 5){ for(Particule p : hashmap.get(d)){ p.color = Color.RED; } }
	 * if(hashmap.get(d).size() == 4){ for(Particule p : hashmap.get(d)){
	 * p.color = Color.BLUE; } }if(hashmap.get(d).size() == 3){ for(Particule p
	 * : hashmap.get(d)){ p.color = Color.GREEN; } }if(hashmap.get(d).size() ==
	 * 2){ for(Particule p : hashmap.get(d)){ p.color = Color.YELLOW; } }
	 * if(hashmap.get(d).size() == 1){ for(Particule p : hashmap.get(d)){
	 * p.color = Color.PINK; } }
	 * 
	 * if(hashmap.get(d).size() == 7){ for(Particule p : hashmap.get(d)){
	 * p.color = Color.ORANGE; } } } }
	 */

	private Double plusPetiteDistance(Particule p1, Particule p2) {
		Double distance = Math
				.sqrt(Math.pow((p2.x - p1.x), 2) + Math.pow((p2.y - p1.y), 2) + Math.pow((p2.z - p1.z), 2));
		return distance;
	}

	private void plusProcheVoisin() {
		HashMap<Double, ArrayList<Particule>> hashmap = new HashMap<Double, ArrayList<Particule>>();

		for (Particule p1 : this.alParticules) {
			Double plusPetiteDistance = 1000.00;
			for (Particule p2 : this.alParticules) {

				if (!p1.estEgal(p2)) {
					// System.out.println("P1 : " + p1 + " P2: " + p2);
					Double distanceP1P2 = plusPetiteDistance(p1, p2);
					// System.out.println("DP1P2: " + distanceP1P2 + " \n");
					// System.out.println(p1.estPasEgal(p2));
					// System.out.println("P1 pas egal P2 : " +
					// p1.estPasEgal(p2));
					if (plusPetiteDistance > distanceP1P2) {

						// System.out.println("non Nan");
						if (p1.plusProcheVoisin != null
								&& (calculPente(p1, p2) <= 10.000 && calculPente(p1, p2) != 0.0
										&& !calculPente(p1, p2).isNaN() && !p2.dejaVoisin)
								&& distanceP1P2 > 0.01 && p2.nbVoisin <= 2) {
							// System.out.println("Calcul pente " +
							// calculPente(p1,p2) );
							// System.out.println("Autre voisin plus proche");
							p1.plusProcheVoisin.dejaVoisin = false;
							p1.enleverVoisin();

						}

						// System.out.println("PPD: " + plusPetiteDistance + "
						// \n");
						plusPetiteDistance = distanceP1P2;
						// System.out.println("PPD: " + plusPetiteDistance + "
						// \n");
						p1.ajouterVoisin(p2);
						p1.plusProcheVoisin.dejaVoisin = true;

						double vitesse = distanceP1P2;

						BigDecimal bd = new BigDecimal(vitesse);
						bd = bd.setScale(3, BigDecimal.ROUND_DOWN);
						vitesse = bd.doubleValue();
						p1.vitesse = vitesse;

					}
				}
			}

			if (hashmap.containsKey(p1.vitesse)) {
				hashmap.get(p1.vitesse).add(p1);
			} else {
				hashmap.put(p1.vitesse, new ArrayList<Particule>());
				hashmap.get(p1.vitesse).add(p1);
			}
		}
		// System.out.println("fini");

		/*
		 * ArrayList<Double> alVitesses = new ArrayList<Double>();
		 * alVitesses.addAll(hashmap.keySet());
		 * 
		 * System.out.println("nb Particules : "+this.alParticules.size());
		 * System.out.println("nb Rayons : "+alVitesses.size());
		 * 
		 * for(Double d : alVitesses){
		 * System.out.println("Vitesse : "+d+" ! nbPoint : "+hashmap.get(d).size
		 * ());
		 * 
		 * if(hashmap.get(d).size() == 5){ for(Particule p : hashmap.get(d)){
		 * p.color = Color.RED; } } }
		 */

		Particule p1 = this.alParticules.get(40);
		p1.color = Color.GREEN;
		// Particule p2 = this.alParticules.get(40);
		// System.out.println("p1 == 2 ? " + p1.estEgal(p2));
		// System.out.println(p1);
		 Particule p2 = p1.plusProcheVoisin;
		 p2.color = Color.BLUE;
		// System.out.println("plus proche voisin de p1 : " +
		// p1.plusProcheVoisin);
		 Particule p3 = p2.plusProcheVoisin;
		 p3.color = Color.RED;
		// Particule p4 = p3.plusProcheVoisin;
		// p4.color = Color.YELLOW;

	}

	
//	 private Double calculPente(Particule p1, Particule p2) {
//	 Double angle = 0.0;
//	 // System.out.println("xP2 :" + p2.x);
//	 // System.out.println("xP1 :" + p1.x);
//	 angle = Math.abs((p2.y - p1.y) / (p2.x - p1.x));
//	 // System.out.println("" + angle);
//	 if (angle.isNaN()) {
//	 angle = 0.0;
//	 }
//	 return angle;
//	 }
	private Double calculPente(Particule p1, Particule p2) {
		double angle = 0;
		double produitScalNormalise = ((p1.x / p1.norme) * (p2.x / p2.norme)) + ((p1.y / p1.norme) * (p2.y / p2.norme))
				+ ((p1.z / p1.norme) * (p2.z / p2.norme));

		System.out.println("" + produitScalNormalise);
		angle = Math.toDegrees(Math.acos(produitScalNormalise));
		System.out.println(" angle " + angle);
		return angle;
	}

	public static void main(String[] args) {
		// Graph g = new Graph();
		// g.lectureDonnees("./donnees/norma_N5_tau4_dt2_delai820_000000.txt");

		JFrame f = new JFrame();
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		f.add(new Graph("./donnees/norma_N5_tau4_dt2_delai820_000004.txt"));

		f.setSize(1050, 370);
		f.setVisible(true);

	}
}
